#import <Foundation/NSObject.h>

@class NSString;
@class NSSet;
@class NSScanner;
@class NSCharacterSet;
@class NSMutableArray;

@interface ObjCConstruct : NSObject <NSCopying>
{
}

+ (unsigned int)indentSpaces;
+ (NSString *)indentString;
+ (void)setIndentSpaces:(unsigned int)newIndent;

+ (BOOL)headingComments;
+ (BOOL)trailingComments;
+ (void)setHeadingComments:(BOOL)yn;
+ (void)setTrailingComments:(BOOL)yn;

- initFromScanner:(NSScanner *)scanner;

- (NSString *)constructType;
- (NSString *)text;

- (NSSet *)neededTypeDeclarations;
- (NSSet *)neededClassDefinitions;
- (NSSet *)neededProtocolDefinitions;

- (NSString *)_scanArbitraryCode:(NSScanner *)scanner upTo:(NSCharacterSet *)endSet;
- (void)_readWhitespaceInto:(NSMutableArray *)contents fromScanner:(NSScanner *)scanner;
- (void)_removeLineAtIndex:(unsigned int)index fromContents:(NSMutableArray *)array;

@end
